<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb60c247f2928281_42185361/operators/FlowchartOperator_lb60c247f2928281_42185361.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb60c247f2928281_42185361/ControlFlow_lb60c247f2928281_42185361.php';
require_once 'custom/PxRoutines/LogicBuilderPackages/lb60c247f2928281_42185361/dataStorage/CollectionStorage_lb60c247f2928281_42185361.php';


class ForEachElementOperator_lb60c247f2928281_42185361 extends FlowchartOperator_lb60c247f2928281_42185361{

    protected $flowId;
    protected $collectionId;
    protected $currentElement;

    protected $loopControlPort;

    public function __construct($params)
    {
        parent::__construct($params);
        $this->flowId = !empty($params['flowId']) ? $params['flowId'] : Sugarcrm\Sugarcrm\Util\Uuid::uuid1();
    }

    public function process($params = array())
    {
        $flowId = $params['flowId'];
        $flowName = $params['flowName'];
        $tearOff = false;
        foreach (CollectionStorage_lb60c247f2928281_42185361::getCollection($this->collectionId) as $element) {
            $this->currentElement = $element;
            $nextLinkParam = self::getNextLink($flowId, $this->getElementId(), $this->loopControlPort);

            if ($nextLinkParam['toOperator'] == $this->id) {
                $tearOff = true;
            } else {
                while (($nextLinkParam = self::getNextElement($flowId, $flowName, $this->id, $nextLinkParam)) != false) {
                    if ($nextLinkParam['toOperator'] == $this->id) {
                        $tearOff = true;
                        break;
                    }
                }
                OperatorStack_lb60c247f2928281_42185361::getInstance()->clearForEachOperators($flowId, $this->id);
            }
            if($tearOff) {
                break;
            }
        }
    }

    protected function setOutControlPort($params)
    {
        if (!empty($params['outControlPorts'])) {
            $this->outControlPort = $params['outControlPorts']['controlFlowCompleted']['id'];
            $this->loopControlPort = $params['outControlPorts']['controlFlowLoopBody']['id'];
        }
    }

    public function setInDataPortById($id, $value)
    {
        if ($id == 'elements') {
            if (isset($value['collectionId'])) {
                $this->collectionId = $value['collectionId'];
            } else if (is_array($value)) {
                $this->initCollectionFromArray($value);
            }
        }
    }

    private function initCollectionFromArray($array)
    {
        $this->collectionId = $this->flowId . $this->id;
        CollectionStorage_lb60c247f2928281_42185361::createCollection($this->collectionId);
        foreach ($array as $element) {
            CollectionStorage_lb60c247f2928281_42185361::addElement($this->collectionId, $element);
        }
    }

    public function getOutDataByPortId($portId)
    {
        if ($portId == 'element') {
            return $this->currentElement;
        }
        return $this->outDataPorts[$portId]['value'];
    }

    public static function getNextLink($flowId, $fromOperatorId, $fromPortId)
    {
        foreach(ControlFlow_lb60c247f2928281_42185361::$links[$flowId] as $link) {
            if ($link['fromOperator'] == $fromOperatorId && $link['fromConnector'] == $fromPortId) {
                return $link;
            }
        }
        return false;
    }

    public static function getNextElement($flowId, $flowName, $loopId, $nextLinkParam)
    {
        if (empty($nextLinkParam)) {
            return false;
        }
        foreach (ControlFlow_lb60c247f2928281_42185361::$operators[$flowId] as $operatorParams) {
            $opId = $operatorParams['id'];
            if ($opId == $nextLinkParam['toOperator']) {
                if (!OperatorStack_lb60c247f2928281_42185361::getInstance()->getOperatorOne($flowId, $opId)) {
                    OperatorStack_lb60c247f2928281_42185361::getInstance()->setForEachOperator($flowId, $loopId, $operatorParams);
                }
                if (OperatorStack_lb60c247f2928281_42185361::getInstance()->getOperatorOne($flowId, $opId)) {
                    self::setInData($flowId, $flowName, $loopId, $opId);
                    OperatorStack_lb60c247f2928281_42185361::getInstance()->getOperatorOne($flowId, $opId)->process(array('flowId' => $flowId, 'flowName' => $flowName));
                    return self::getNextLink(
                        $flowId,
                        OperatorStack_lb60c247f2928281_42185361::getInstance()->getOperatorOne($flowId, $opId)->getElementId(),
                        OperatorStack_lb60c247f2928281_42185361::getInstance()->getOperatorOne($flowId, $opId)->getOutControlPort()
                    );
                }
                return false;
            }
        }
        return false;
    }

    protected static function setInData($flowId, $flowName, $loopId, $operatorId)
    {
        $toOperatorId = OperatorStack_lb60c247f2928281_42185361::getInstance()->getOperatorOne($flowId, $operatorId)->getElementId();
        $inputDataPorts = OperatorStack_lb60c247f2928281_42185361::getInstance()->getOperatorOne($flowId, $operatorId)->getInDataPorts();
        foreach ($inputDataPorts as $inPortKey => $inDataPort) {
            $prevLink = self::getPrevLink($flowId, $toOperatorId, $inPortKey);
            if (empty($prevLink)) {
                continue;
            }
            if (OperatorStack_lb60c247f2928281_42185361::getInstance()->getOperatorOne($flowId, $prevLink['fromOperator'])) {
                $value = OperatorStack_lb60c247f2928281_42185361::getInstance()->getOperatorOne($flowId, $prevLink['fromOperator'])->getOutDataByPortId($prevLink['fromConnector']);
                OperatorStack_lb60c247f2928281_42185361::getInstance()->getOperatorOne($flowId, $operatorId)->setInDataPortById($inPortKey, $value);
            } else {
                self::getPrevElementForDataFlow($flowId, $flowName, $loopId, $prevLink['fromOperator']);
                $value = OperatorStack_lb60c247f2928281_42185361::getInstance()->getOperatorOne($flowId, $prevLink['fromOperator'])->getOutDataByPortId($prevLink['fromConnector']);
                OperatorStack_lb60c247f2928281_42185361::getInstance()->getOperatorOne($flowId, $operatorId)->setInDataPortById($inPortKey, $value);
            }
        }
    }

    protected static function getPrevLink($flowId, $toOperatorId, $toPortId)
    {
        foreach (ControlFlow_lb60c247f2928281_42185361::$links[$flowId] as $link) {
            if ($link['toOperator'] == $toOperatorId && $link['toConnector'] == $toPortId) {
                return $link;
            }
        }
        return array();
    }

    protected static function getPrevElementForDataFlow($flowId, $flowName, $loopId, $elemId)
    {
        foreach (ControlFlow_lb60c247f2928281_42185361::$operators[$flowId] as $operatorInfo) {
            if ($operatorInfo['id'] == $elemId) {
                if (!OperatorStack_lb60c247f2928281_42185361::getInstance()->getOperatorOne($flowId, $elemId)) {
                    OperatorStack_lb60c247f2928281_42185361::getInstance()->setForEachOperator($flowId, $loopId, $operatorInfo);
                }
                self::setInData($flowId, $flowName, $loopId, $elemId);
                OperatorStack_lb60c247f2928281_42185361::getInstance()->getOperatorOne($flowId, $elemId)->process(array('flowId' => $flowId, 'flowName' => $flowName));
            }
        }
    }
}
