<?php

require_once 'custom/PxRoutines/LogicBuilderPackages/lb60c247f2928281_42185361/operators/FlowchartOperator_lb60c247f2928281_42185361.php';

require_once "modules/Mailer/MailerFactory.php";
require_once 'custom/PxRoutines/LogicBuilderPackages/lb60c247f2928281_42185361/helpers/FlowchartAttachmentPeer_lb60c247f2928281_42185361.php';

class SendEmailOperator_lb60c247f2928281_42185361 extends FlowchartOperator_lb60c247f2928281_42185361
{

    protected $attachmentPeer;
    protected $notifyMail;

    protected $fromAddress;
    protected $fromName;

    protected $toAddrArr = array();
    protected $toEmail;
    protected $toName;
    protected $ccAddresses = array();
    protected $subjectText;
    protected $bodyText;
    protected $attachments;
    protected $saveEntity = false;

    protected $emailEntity = null;
    protected $notesFromAttaches = array();

    //const EMAIL_PATTERN = "/([a-z0-9_\\.-]+)@([\\da-z\\.-]+)\\.([a-z\\.]{2,6})/i";
//    const EMAIL_PATTERN = '/(("([^"]*)"|[^",]*)\\s*<(.*?)>|[^",\\s]+)(?=(,|$))/';
    const EMAIL_PATTERN = '/(("([^"]*)"|[^";,]*)\\s*<(.*?)>|[^";,\\s]+)(?=(;|,|$))/';

    protected $filesToCleanUp = array();

    public function __construct($params){
        parent::__construct($params);
    }

    public function process($params = array()){
        //Name must be initialize before the address
        if(!empty($this->inDataPorts['fromName']['value']))
            $this->fromName = $this->inDataPorts['fromName']['value'];
        if(!empty($this->inDataPorts['fromAddress']['value'])){
            $fromAddresses = $this->parseRawAddresses($this->inDataPorts['fromAddress']['value']);
            $this->setFromAddress($fromAddresses);
        }

        //Name must be initialize before the address
        if(!empty($this->inDataPorts['toName']['value']))
            $this->toName = $this->inDataPorts['toName']['value'];
        if(!empty($this->inDataPorts['toAddress']['value'])){
            $toAddresses = $this->parseRawAddresses($this->inDataPorts['toAddress']['value']);
            $this->setToAddresses($toAddresses);
        }
        if(!empty($this->inDataPorts['ccAddresses']['value'])){
            $ccAddresses = $this->parseRawAddresses($this->inDataPorts['ccAddresses']['value']);
            $this->setCCAddresses($ccAddresses);
        }
        if(!empty($this->inDataPorts['subject']['value']))
            $this->subjectText = $this->inDataPorts['subject']['value'];
        if(!empty($this->inDataPorts['text']['value']))
            $this->bodyText = $this->inDataPorts['text']['value'];
        if(!empty($this->inDataPorts['attachments']['value'])){
            $this->attachments = $this->inDataPorts['attachments']['value'];
        }

        if(!empty($this->inDataPorts['save']['value'])){
            $this->saveEntity = $this->inDataPorts['save']['value'];
        }

        $this->sendEmail();
    }

    protected function parseRawAddresses($rawAddressesData){
        if(empty($rawAddressesData))
            return array();

        $addresses = array();
        if(is_string($rawAddressesData)){
            $matches = array();
            preg_match_all(self::EMAIL_PATTERN, $rawAddressesData, $matches, PREG_SET_ORDER);

            foreach($matches as $match){
                $email = trim($match[4]) ?: $match[1];
                if(!empty($email)){
                    $addresses[] = [
                        'display' => $match[3] ?: trim($match[2]),
                        'email' => $email
                    ];
                }
            }
            foreach($addresses as $key => $rawAddressData){
                $pattern = "/^([a-z0-9_\\.-]+)@([\\da-z\\.-]+)\\.([a-z\\.]{2,6})$/i";
                if((empty($rawAddressData['email']) || !preg_match($pattern, $rawAddressData['email'])) && !empty($addresses[$key+1])){
                    $parts = array();
                    if(!empty($rawAddressData['display']))
                        $parts[] = $rawAddressData['display'];
                    if(!empty($rawAddressData['email']))
                        $parts[] = $rawAddressData['email'];
                    $parts[] = $addresses[$key+1]['display'];
                    $addresses[$key+1]['display'] = implode(', ', $parts);
                    unset($addresses[$key]);
                }
            }
            return $addresses;
        } elseif(is_array($rawAddressesData)){
            $pattern = "/^([a-z0-9_\\.-]+)@([\\da-z\\.-]+)\\.([a-z\\.]{2,6})$/i";
            foreach($rawAddressesData as $rawAddressData){
                if(!empty($rawAddressData['email']) && preg_match($pattern, $rawAddressData['email'])){
                    $addresses[] = [
                        'display' => !empty($rawAddressData['display']) ? $rawAddressData['display'] : '',
                        'email' => $rawAddressData['email']
                    ];
                }
            }
        }
        return $addresses;
    }

    protected function setFromAddress($addresses){
        if(!empty($addresses)){
            $this->fromAddress = $addresses[0]['email'];
            $this->fromName = !empty($this->fromName) ? $this->fromName : $addresses[0]['email'];
        }
    }

    protected function setToAddresses($addresses){
        if(!empty($addresses)){
            $this->toAddrArr = !empty($addresses[0]) ? $addresses : array($addresses);
            if(!empty($this->toName)){
                $this->toAddrArr[0]['display'] = $this->toName;
            }
        }
    }

    protected function setCCAddresses($addresses){
        if(!empty($addresses)){
            if(empty($this->toAddrArr)){
                $this->setToAddresses(array_pop($addresses));
            }
            $this->ccAddresses = $addresses;
        }
    }

    protected function sendEmail(){
        global $app_strings, $current_user;

        try{
            $mailConfig = OutboundEmailConfigurationPeer::getSystemMailConfiguration($current_user);
            $this->notifyMail = MailerFactory::getMailer($mailConfig);

            if(is_array($this->toAddrArr)){
                foreach($this->toAddrArr as $addr_arr){
                    try{
                        $this->notifyMail->addRecipientsTo(new EmailIdentity($addr_arr['email'], $addr_arr['display']));
                    } catch(MailerException $me){
                    }
                }
            }
            if(is_array($this->ccAddresses)){
                foreach($this->ccAddresses as $addr_arr){
                    try{
                        $this->notifyMail->addRecipientsCc(new EmailIdentity($addr_arr['email'], $addr_arr['display']));
                    } catch(MailerException $me){
                    }
                }
            }

            if (empty($this->fromAddress)) {
                $this->fromAddress = $current_user->getPreference('mail_fromaddress');
            }
            if (empty($this->fromName)) {
                $this->fromName = $current_user->getPreference('mail_fromname');
            }
            if(empty($this->fromAddress)){
                require_once("modules/Administration/Administration.php");
                $admin = new Administration();
                $admin->retrieveSettings();
                $this->fromAddress = $admin->settings['notify_fromaddress'];
                $this->fromName = (empty($admin->settings['notify_fromname'])) ? "" : $admin->settings['notify_fromname'];
            }
            if(empty($this->fromAddress)){
                $this->fromAddress = $current_user->emailAddress->getReplyToAddress($current_user);
                $this->fromName = !empty($current_user->full_name) ? $current_user->full_name : $current_user->user_name;
            }

            $replyToAddr = $this->fromAddress;
            $replyToName = $this->fromName;

            $this->notifyMail->setHeader(EmailHeaders::From, new EmailIdentity($this->fromAddress, $this->fromName));
            $this->notifyMail->setHeader(EmailHeaders::ReplyTo, new EmailIdentity($replyToAddr, $replyToName));
            $this->notifyMail->setSubject($this->subjectText);

            if(!empty($this->attachments)){
                $this->handleAttachments();
            }

            $textBody = $htmlBody = $this->bodyText;

            $email = BeanFactory::getBean('Emails');
            if(trim($htmlBody) != '' && $current_user->getPreference('email_editor_option', 'global') !== 'plain' //user preference is not set to plain text
            ){
                $htmlBody = $email->decodeDuringSend($htmlBody);
                $textBody = $email->decodeDuringSend($textBody);
            } else{
                $textBody = str_replace("&nbsp;", " ", $textBody);
                $textBody = str_replace("</p>", "</p><br />", $textBody);
                $textBody = strip_tags(br2nl($textBody));
                $textBody = str_replace("&amp;", "&", $textBody);
                $textBody = str_replace("&#39;", "'", $textBody);
                $textBody = $email->decodeDuringSend($textBody);
            }

            $this->notifyMail->setHtmlBody($htmlBody);
            $this->notifyMail->setTextBody($textBody);

            $this->notifyMail->send();
            $message_id = $this->notifyMail->getHeader(EmailHeaders::MessageId);

            $this->createEmailEntity();
            $this->cleanUp();
        } catch(MailerException $me){
            $GLOBALS["log"]->fatal($me->getLogMessage());
        } catch(Exception $e){
            $GLOBALS['log']->fatal($app_strings['LBL_EMAIL_ERROR_PREPEND'] . $e->getMessage());
        }
    }

    protected function handleAttachments(){
        $this->attachmentPeer = new FlowchartAttachmentPeer_lb60c247f2928281_42185361($this->saveEntity);
        $attachments = $this->attachmentPeer->processFiles($this->attachments);
        foreach($attachments as $attachment){
            $this->notifyMail->addAttachment($attachment);
        }
    }

    protected function cleanUp(){
        if(!empty($this->attachmentPeer)){
            $this->attachmentPeer->cleanUp();
        }
    }

    protected function createEmailEntity(){
        if(!$this->saveEntity)
            return;

        $this->emailEntity = BeanFactory::getBean('Emails');
        $this->emailEntity->from_addr = $this->fromAddress;
        $this->emailEntity->from_addr_name = $this->fromName;
        $this->emailEntity->to_addrs = $this->getStringFromAddressArray($this->toAddrArr);
        $this->emailEntity->cc_addrs = $this->getStringFromAddressArray($this->ccAddresses);
        $this->emailEntity->name = $this->subjectText;
        $this->emailEntity->description_html = $this->bodyText;
        $this->emailEntity->save();

        if(!empty($this->attachmentPeer)){
            $notesFromAttaches = $this->attachmentPeer->getAttachedNotes();
        }
        if(!empty($notesFromAttaches)){
            $this->emailEntity->load_relationship('notes');
            $this->emailEntity->notes->add($notesFromAttaches);
        }
    }

    protected function getStringFromAddressArray($addresses) {
        if (!is_array($addresses)) {
            return $addresses;
        }
        try {
            $result = '';
            foreach ($addresses as $address) {
                if (!empty($result)) {
                    $result .= ', ';
                }
                $result .= $this->getCompositeAddressFromArray($address);
            }
            return $result;
        } catch (Exception $e) {
            $GLOBALS['log']->fatal($e->getMessage());
            return '';
        }
    }

    protected function getCompositeAddressFromArray($address) {
        if (!is_array($address)) {
            return $address;
        }
        if (!isset($address['email'])) {
            return '';
        }
        return $this->compositeAddress(
            $address['email'],
            isset($address['display']) ? $address['display'] : ''
        );
    }

    protected function compositeAddress($address, $name = ''){
        if(!empty($name)){
            return $name . ' <' . $address . '>';
        }
        return $address;
    }

    public function getOutDataByPortId($portId){
        return $this->emailEntity;
    }
}
